/*
   Move the definitions of the Comparator classes
   into this file as private classes.
*/
import java.util.Comparator;
import java.util.Arrays;
import java.util.List;

public class Comparator_base_v1
{
   public static void main(String[] args)
   {
      List<Country> countries = Arrays.asList(
         new Country("Uruguay",   176220,   3.4),
         new Country("Thailand",  514000,  67.0),
         new Country("Belgium",    30528,  11.0),
         new Country("Zaire",    2345410,  46.5),
         new Country("Belize",     22966,   0.334));

      countries.sort(new CountryComparatorByArea_a());
      countries.forEach(System.out::println); System.out.println();

      countries.sort(new CountryComparatorByArea_d());
      countries.forEach(System.out::println); System.out.println();

      countries.sort(new CountryComparatorByPopulation_a());
      countries.forEach(System.out::println); System.out.println();

      countries.sort(new CountryComparatorByPopulation_d());
      countries.forEach(System.out::println); System.out.println();

      countries.sort(new CountryComparatorByName_a());
      countries.forEach(System.out::println); System.out.println();

      countries.sort(new CountryComparatorByName_d());
      countries.forEach(System.out::println); System.out.println();
   }
}


class CountryComparatorByArea_a implements Comparator<Country>
{
   public int compare(Country c1, Country c2) {
      if (c1.getArea() < c2.getArea() ) return -1;
      if (c1.getArea() > c2.getArea() ) return  1;
      return 0;
   }
}

class CountryComparatorByArea_d implements Comparator<Country>
{
   public int compare(Country c1, Country c2) {
      if (c1.getArea() > c2.getArea() ) return -1;
      if (c1.getArea() < c2.getArea() ) return  1;
      return 0;
   }
}

class CountryComparatorByPopulation_a implements Comparator<Country>
{
   public int compare(Country c1, Country c2) {
      if (c1.getPopulation() < c2.getPopulation() ) return -1;
      if (c1.getPopulation() > c2.getPopulation() ) return  1;
      return 0;
   }
}

class CountryComparatorByPopulation_d implements Comparator<Country>
{
   public int compare(Country c1, Country c2) {
      if (c1.getPopulation() > c2.getPopulation() ) return -1;
      if (c1.getPopulation() < c2.getPopulation() ) return  1;
      return 0;
   }
}

class CountryComparatorByName_a implements Comparator<Country>
{
   public int compare(Country c1, Country c2) {
      return c1.getName().compareTo(c2.getName());
   }
}

class CountryComparatorByName_d implements Comparator<Country>
{
   public int compare(Country c1, Country c2) {
      return c2.getName().compareTo(c1.getName());
   }
}


class Country
{
   private String name;
   private double area;
   private double population;

   public Country(String name, double area, double population) {
      this.name = name;
      this.area = area;
      this.population = population;
   }

   public String getName() { return this.name; }

   public double getArea() { return this.area; }

   public double getPopulation() { return this.population; }

   public String toString() {
      return name + ": area = " + area + ", population = " + population;
   }
}
