import java.util.Comparator;

public class CountryComparator<T> implements Comparator<Country>
{
   Fn<T> fn;    // functor that holds <, >, <=, or >=
   Get<T> get;  // get method

   CountryComparator(Fn<T> fn, Get<T> get)
   {
      this.fn = fn;
      this.get = get;
   }

   public int compare(Country c1, Country c2)
   {
      if ( fn.fn(get.get(c1), get.get(c2)) ) return -1;
      if (!fn.fn(get.get(c1), get.get(c2)) ) return  1;
      return 0;
   }
}
