/*
   Create parameterized comparators that
   are as close to Scheme's as possible.
*/
import java.util.*;

public class Java8_Comparator_base
{
   public static void main(String[] args)
   {
      List<Country> countries = Arrays.asList(
         new Country("Uruguay",   176220,   3.4),
         new Country("Thailand",  514000,  67.0),
         new Country("Belgium",    30528,  11.0),
         new Country("Zaire",    2345410,  46.5),
         new Country("Belize",     22966,   0.334));

      countries.sort((c1, c2) -> c1.getName().compareTo(c2.getName()));
      countries.forEach(c -> System.out.println(c)); System.out.println();

      countries.sort((c1, c2) -> c2.getName().compareTo(c1.getName()));
      countries.forEach(System.out::println); System.out.println();

      countries.sort((c1,c2) -> c1.getArea().compareTo(c2.getArea()));
      countries.forEach(System.out::println); System.out.println();

      countries.sort((c1,c2) -> c2.getArea().compareTo(c1.getArea()));
      countries.forEach(System.out::println); System.out.println();

      countries.sort((c1,c2) -> c1.getPopulation().compareTo(c2.getPopulation()));
      countries.forEach(System.out::println); System.out.println();

      countries.sort((c1,c2) -> c2.getPopulation().compareTo(c1.getPopulation()));
      countries.forEach(System.out::println); System.out.println();
   }
}


class Country
{
   private String name;
   private Double area;        // note the small change here
   private Double population;  // note the small change here

   public Country(String name, double area, double population) {
      this.name = name;
      this.area = area;
      this.population = population;
   }

   public String getName() { return this.name; }

   public Double getArea() { return this.area; }

   public Double getPopulation() { return this.population; }

   public String toString() {
      return name + ": area = " + area + ", population = " + population;
   }
}
